#include <stdlib.h>
#include <stdio.h>

#define N 10
#define U 11
#define M 12
#define B 13
#define E 14
#define R 15
#define S 16

int solve_sudoku(int i);
int check_sudoku(int r, int c);
void print_sudoku();

char specials[] = "NUMBERS";

int sudoku[16][16] = {{0,R,0,M,4,0,0,9,0,E,0,S,8,0,0,0},
                      {S,0,7,0,0,R,2,0,1,0,0,6,0,0,0,5},
                      {0,0,0,8,0,7,5,0,9,0,3,0,0,0,6,2},
                      {0,E,0,0,M,0,0,3,B,0,0,0,0,U,4,0},
                      {1,0,0,6,0,0,7,B,0,N,5,0,E,0,0,M},
                      {0,3,8,0,0,0,1,0,0,0,0,U,2,0,B,0},
                      {0,N,E,0,0,4,0,8,R,0,0,B,3,5,0,0},
                      {9,0,0,B,2,U,0,0,0,M,6,0,0,S,0,0},
                      {0,5,2,0,0,N,0,0,0,B,0,9,6,1,0,U},
                      {4,0,3,0,0,1,0,6,M,0,E,0,0,2,R,0},
                      {N,U,9,0,7,0,0,R,8,0,0,0,0,M,S,0},
                      {0,0,0,R,0,0,9,0,0,3,U,0,7,0,0,B},
                      {R,0,0,0,0,M,E,0,2,0,0,4,0,0,0,3},
                      {B,S,0,5,0,0,0,N,0,U,7,0,1,0,E,0},
                      {0,0,4,0,0,5,8,0,0,1,9,0,N,7,0,S},
                      {0,1,U,0,6,3,0,0,5,0,0,N,B,0,0,0}};

int n = 0;

int main()
{
  print_sudoku();

  if (solve_sudoku(0))
  {
    printf("Solution found after %d moves\n\n", n);
    print_sudoku();
  }
  else
    printf("No solution found after %d moves\n", n);
}

int solve_sudoku(int i)
{
  int r, c;

  if (i<0) return 0;
  else if (i>=256) return -1;

  r = i/16; c = i%16;
  if (sudoku[r][c])
    return check_sudoku(r, c) && solve_sudoku(i+1);
  else
    for (sudoku[r][c]=16; sudoku[r][c]>0; sudoku[r][c]--)
      if (solve_sudoku(i)) return -1;

  return 0;
}

int check_sudoku(int r, int c)
{
  int i;
  int rr, cc;

  n++;
  //print_sudoku();
  for (i=0; i<16; i++)
  {
    if (i!=c && sudoku[r][i]==sudoku[r][c]) return 0;
    if (i!=r && sudoku[i][c]==sudoku[r][c]) return 0;
    rr = r/4*4+i/4; cc = c/4*4+i%4;
    if ((rr!=r || cc!=c) && sudoku[rr][cc]==sudoku[r][c]) return 0;
    if (r==c && i!=r && sudoku[i][i]==sudoku[r][c]) return 0;
    if (r==15-c && i!=r && sudoku[i][15-i]==sudoku[r][c]) return 0;
  }
  return -1;
}

void print_sudoku()
{
  int i, j;

  for (i=0; i<16; i++)
  {
    for (j=0; j<16; j++)
      if (sudoku[i][j]>9)
        printf(" %c", specials[sudoku[i][j]-10]);
      else
        printf(" %d", sudoku[i][j]);
    printf("\n");
  }
  printf("\n");
}
